/*======================================================================*//**
 * 
 * com.ytti Classes
 * 
 * @author Copyright (c) 2009 y-tti.com
 * @version 3.0.5
 * @see http://www.y-tti.com/
 * 
 * Developed by y-tti
 * @see http://www.y-tti.com/
 * 
 * this is released under the MIT License:
 * http://www.opensource.org/licenses/mit-license.php
 * 
 */
package com.ytti.mesh.core
{
	
	import flash.display.BitmapData;
	import flash.display.Sprite;
	import flash.geom.Matrix;
	import flash.geom.Point;
	
	public class BitmapDataMesh extends Mesh
	{
		private var _bmd:BitmapData;
		private var _segmentW:Number;
		private var _segmentH:Number;
		private var _color:uint;
		private var _linevisible:Boolean;
		
		public function BitmapDataMesh( $bmd:BitmapData , $aInitPoint:Array , $segmentsW:Number=0, $segmentsH:Number=0 ,$color:uint = 0xFF0000 ,$linevisible:Boolean=false)
		{
			_bmd = $bmd;
			_segmentW = $segmentsW;
			_segmentH = $segmentsH;
			_color = $color;
			_linevisible = $linevisible;
			super();
			
			this.bmdWidth = _bmd.width;
			this.bmdHeight = _bmd.height;
			this.aInitPoint = $aInitPoint;
			this.aInitTriangle = this.getMeshTriangles( this.aInitPoint , _segmentW , _segmentH );
			this.aInitTransformMatrix = this.getInitTransformMatrix(this.aInitTriangle);
			
		}
		
		public function render($canvas:Sprite , $editPoints:Array):void {
			var atri:Array = this.getMeshTriangles($editPoints , _segmentW , _segmentH);
			
			var pd0:Point;
			var pd1:Point;
			var pd2:Point;
			var tri:MeshTriangle;
			var mat:Matrix;
			
			$canvas.graphics.clear();
			for (var i:int = 0; i < atri.length; ++i)
			{
				tri = atri[i] as MeshTriangle;
				pd0 = tri.p0;
				pd1 = tri.p1;
				pd2 = tri.p2;
				
				mat = this.aInitTransformMatrix[i].clone();
				mat.concat(this.getTransformMatrix(pd0, pd1, pd2));
				$canvas.graphics.beginBitmapFill(_bmd, mat , false , true);
				if(_linevisible) $canvas.graphics.lineStyle(1, _color);
				$canvas.graphics.moveTo(pd0.x, pd0.y);
				$canvas.graphics.lineTo(pd1.x, pd1.y);
				$canvas.graphics.lineTo(pd2.x, pd2.y);
				$canvas.graphics.lineTo(pd0.x, pd0.y);
				$canvas.graphics.endFill();
			}
		}

	}
}