/*======================================================================*//**
 * 
 * com.ytti Classes
 * 
 * @author Copyright (c) 2009 y-tti.com
 * @version 3.0.5
 * @see http://www.y-tti.com/
 * 
 * Developed by y-tti
 * @see http://www.y-tti.com/
 * 
 * this is released under the MIT License:
 * http://www.opensource.org/licenses/mit-license.php
 * 
 */
package com.ytti.mesh.core
{
	import flash.geom.Matrix;
	import flash.geom.Point;
	
	public class Mesh
	{
		private var _aInitPoint:Array;
		private var _aInitTriangle:Array;
		private var _aInitTransformMatrix:Array;
		private var _bmdWidth:Number;
		private var _bmdHeight:Number;
		
		public function get bmdWidth():Number{return _bmdWidth;};
		public function set bmdWidth($value:Number):void{_bmdWidth = $value;};
		public function get bmdHeight():Number{return _bmdHeight;};
		public function set bmdHeight($value:Number):void{_bmdHeight = $value;};
		public function get aInitPoint():Array{return _aInitPoint;};
		public function set aInitPoint($value:Array):void{_aInitPoint = $value;};
		public function get aInitTriangle():Array{return _aInitTriangle;};
		public function set aInitTriangle($value:Array):void{_aInitTriangle = $value;}
		public function get aInitTransformMatrix():Array{return _aInitTransformMatrix;};
		public function set aInitTransformMatrix($value:Array):void{_aInitTransformMatrix = $value;}
		
		public function Mesh()
		{
		}
		
		/*======================================================================*//**
		 * <p>MeshTriangleを配列を返します。</p>
		 * <p></p>
		 * 
		 * @langversion 3.0
		 * @playerversion Flash 9.0.45.0
		 * 
		 * @param 
		 * 	<p></p>
		 */
		public function getMeshTriangles($aPoint:Array , $segmentW:Number , $segmentH:Number):Array {
			var idx:Number = 0;
			var aTriangle:Array = [];
			for(var iy:Number = 0;iy <= $segmentH;iy++ ){
				for(var ix:Number = 0;ix <= $segmentW;ix++ ){
					if( ix == $segmentW || iy ==$segmentH ) {
					} else {
						var p0:Point = $aPoint[idx];
						var p1:Point = $aPoint[idx+1];
						var p2:Point = $aPoint[idx+$segmentW+1];
						var p3:Point = $aPoint[idx+$segmentW+2];
						var tri1:MeshTriangle = new MeshTriangle(p0, p1 , p2 );
						aTriangle.push(tri1);
						var tri2:MeshTriangle = new MeshTriangle(p3, p2 , p1 );
						aTriangle.push(tri2);
					}
					idx++;
				}
			}
			return aTriangle;
		}
		
		/*======================================================================*//**
		 * <p>各MeshTriangleデフォルト値のmatrixの配列を返します。</p>
		 * <p></p>
		 * 
		 * @langversion 3.0
		 * @playerversion Flash 9.0.45.0
		 * 
		 * @param $meshTriangles
		 * 	<p>_getMeshTrianglesで作成したMeshTriangleの配列</p>
		 */
		public function getInitTransformMatrix($meshTriangles:Array):Array
		{
			var triangles:Array = $meshTriangles;
			var tri:MeshTriangle;
			var aReturn:Array = [];
			var mat:Matrix;
			for(var i:int = 0; i < triangles.length; ++i)
			{
				tri = triangles[i] as MeshTriangle;
				mat = getTransformMatrix(tri.p0, tri.p1, tri.p2);
				mat.invert();
				aReturn.push(mat);
			}
			return aReturn;
		}
		
		/*======================================================================*//**
		 * <p>三角形のポイントよりMatrix情報を返す</p>
		 * 
		 * @langversion 3.0
		 * @playerversion Flash 9.0.45.0
		 * 
		 * @param $meshTriangles
		 * 	<p>_getMeshTrianglesで作成したMeshTriangleの配列</p>
		 */
		public function getTransformMatrix($pt0:Point, $pt1:Point, $pt2:Point):Matrix
		{
			var w:Number = _bmdWidth;
			var h:Number = _bmdHeight;
			var mat:Matrix = new Matrix();
			mat.a = ($pt1.x - $pt0.x) / w;
			mat.b = ($pt1.y - $pt0.y) / w;
			mat.c = ($pt2.x - $pt0.x) / h;
			mat.d = ($pt2.y - $pt0.y) / h;
			mat.tx = $pt0.x;
			mat.ty = $pt0.y;
			return mat;
		}
		
	}
}