package
{
	import com.ytti.mesh.core.BitmapDataMesh;
	
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Sprite;
	import flash.display.StageAlign;
	import flash.display.StageQuality;
	import flash.display.StageScaleMode;
	import flash.events.Event;
	import flash.geom.Point;
	
	[SWF(width = "465", height = "465", frameRate = "30", backgroundColor = "0xFFFFFF")]
	public class TestBitmapDataTest extends Sprite
	{
		[Embed(source="test.jpg")] private var ImageClass:Class;
		private var _bmd:BitmapData;
		private var _segmentW:Number = 2;
		private var _segmentH:Number = 2;
		private var _mesh:BitmapDataMesh;
		
		public function TestBitmapDataTest()
		{
			stage.quality = StageQuality.BEST;
			stage.align = StageAlign.TOP_LEFT;
			stage.scaleMode = StageScaleMode.NO_SCALE;
			addEventListener(Event.ADDED_TO_STAGE, _init);
			
		}
		
		private function _init(e:Event):void {
			_bmd = Bitmap(new ImageClass()).bitmapData;
			
			var initPoints:Array = _getPoint(false);
			_mesh = new BitmapDataMesh(_bmd ,initPoints,_segmentW,_segmentH , 0x00FF00);
			
			addEventListener(Event.ENTER_FRAME , _loop );
		}
		
		private function _loop(e:Event):void {
			var editPoints:Array = _getPoint(true);
			_mesh.render(this, editPoints);
		}
		
		private function _getPoint($ramdom:Boolean = false):Array {
			var pts:Array = [];
			var intervalW:Number = _bmd.width / _segmentW;
			var intervalH:Number = _bmd.height / _segmentH;
			
			for(var iy:Number = 0;iy <= _segmentH;iy++ ){
				for(var ix:Number = 0;ix <= _segmentW;ix++ ){
					var px:Number;
					var py:Number;
					if($ramdom){
						px = ix * intervalW + Math.random()*20-10;
						py = iy * intervalH + Math.random()*20-10;
					} else {
						px = ix * intervalW;
						py = iy * intervalH;
					}
					var pt:Point = new Point(px, py);
					pts.push(pt);
				}
			}
			
			return pts;
		}
	}
}