package
{
	import com.ytti.mesh.core.BitmapDataMesh;
	
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Sprite;
	import flash.display.StageAlign;
	import flash.display.StageQuality;
	import flash.display.StageScaleMode;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.filters.BevelFilter;
	import flash.geom.Point;
	
	[SWF(width = "465", height = "465", frameRate = "30", backgroundColor = "0xFFFFFF")]
	public class TestBitmapSquare extends Sprite
	{
		//[Embed(source="test.jpg")] private var ImageClass:Class;
		[Embed(source="robo.png")] private var ImageClass:Class;
		private var _bmd:BitmapData;
		private var _pt1:Point;
		private var _pt2:Point;
		private var _pt3:Point;
		private var _pt4:Point;
		private var _segmentW:Number = 10;
		private var _segmentH:Number = 10;
		private var _w:Number;
		private var _h:Number;
		private var _ptCtop:Point;
		private var _ptCbottom:Point;
		private var _canvas:Sprite;
		private var _angle:Number = 0;
		private var _mesh:BitmapDataMesh;
		
		public function TestBitmapSquare()
		{
			stage.quality = StageQuality.BEST;
			stage.align = StageAlign.TOP_LEFT;
			stage.scaleMode = StageScaleMode.NO_SCALE;
			addEventListener(Event.ENTER_FRAME ,_stageloop);
		}
		
		private function _stageloop(e:Event):void {
			if(stage.stageWidth > 0) {
				_init();
			} 
		}
		
		private function _init():void {
			removeEventListener(Event.ENTER_FRAME ,_stageloop);
			_bmd = Bitmap(new ImageClass()).bitmapData;
			_w = _bmd.width;
			_h = _bmd.height;
			
			_canvas = addChild(new Sprite()) as Sprite;
			_canvas.x = (stage.stageWidth - _w)/2;
			_canvas.y = (stage.stageHeight - _h)/2;
			
			
			_pt1 = new Point(0,0);
			_pt2 = new Point(_w,0);
			_pt3 = new Point(0,_h);
			_pt4 = new Point(_w,_h);
			_ptCtop = Point.interpolate(_pt1 , _pt2 , 0.5);
			_ptCbottom = Point.interpolate(_pt3 , _pt4 , 0.5);
			
			var initPoints:Array = _getPoint(_pt1,_pt2,_pt3,_pt4,_segmentW,_segmentH,0);
			_mesh = new BitmapDataMesh(_bmd ,initPoints,_segmentW,_segmentH , 0x00FF00 ,true);
			
			
			addEventListener(Event.ENTER_FRAME , _update );
		}
		
		private function _update(e:Event):void {
			//_angle += 1;
			_angle = (mouseX - stage.stageWidth/2)/4;
			var rad1:Number = (_angle +180) * Math.PI /180;
			var rad2:Number = _angle * Math.PI /180; 
			_pt1.x = Math.cos(rad1) * _w/2 + _ptCtop.x;
			_pt1.y = Math.sin(rad1) * _w/2 + _ptCtop.y; 
			_pt2.x = Math.cos(rad2) * _w/2 + _ptCtop.x;
			_pt2.y = Math.sin(rad2) * _w/2 + _ptCtop.y; 
			_pt3.x = Math.cos(-rad1) * _w/2 + _ptCbottom.x;
			_pt3.y = Math.sin(-rad1) * _w/2 + _ptCbottom.y; 
			_pt4.x = Math.cos(-rad2) * _w/2 + _ptCbottom.x;
			_pt4.y = Math.sin(-rad2) * _w/2 + _ptCbottom.y; 
			
			var editPoints:Array = _getPoint(_pt1,_pt2,_pt3,_pt4,_segmentW,_segmentH,_angle);
			_mesh.render(_canvas, editPoints);
		}
		
		private function _getPoint($pt1:Point,$pt2:Point,$pt3:Point,$pt4:Point,$segH:Number,$segW:Number,$angle:Number):Array {
			
			var midL:Point;
			midL = Point.interpolate( _pt1 , _pt3 , 0.5 );
			midL.x += -$angle;
			var midR:Point;
			midR = Point.interpolate( _pt2 , _pt4 , 0.5 );
			midR.x += -_angle;
			
			var iy:Number;
			var ix:Number;
			var tH:Number;
			var tW:Number;
			var pL:Point;
			var pR:Point;
			var p:Point;
			
			var points:Array = [];
			for(iy = 0;iy <= $segH ;iy++ ){
				tH = (1 / ($segH)) * iy;
				pL = _quadraticBeziercurves($pt1 , midL , $pt3 , tH );
				pR = _quadraticBeziercurves($pt2 , midR , $pt4 , tH );
				for(ix = 0;ix <= $segW;ix++ ){
					tW = (1 / ($segW)) * ix;
					p = _linearBeziercurves(pL , pR , tW );
					points.push(p);
					//trace(p);
				}
			}
			
			return points;
		}
		
		private function _linearBeziercurves($p0:Point , $p1:Point , $t:Number):Point {
			//http://en.wikipedia.org/wiki/B%C3%A9zier_curve
			// B(t) = P0 + t(P1-P0) = (1-t)P0 +tP1 , 0<=t<=1
			var xP:Number = $p0.x + $t*($p1.x-$p0.x);
			var yP:Number = $p0.y + $t*($p1.y-$p0.y);
			return new Point(xP ,yP);
		}
		private function _quadraticBeziercurves($p0:Point , $p1:Point , $p2:Point , $t:Number):Point {
			//http://en.wikipedia.org/wiki/B%C3%A9zier_curve
			// B(t) = (1-t)(1-t)P0 + 2(1-t)tP1 + ttP2 , 0<=t<=1
			var xP:Number = Math.pow((1-$t),2) * $p0.x + 2*(1-$t)*$t*$p1.x + $t*$t*$p2.x;
			var yP:Number = Math.pow((1-$t),2) * $p0.y + 2*(1-$t)*$t*$p1.y + $t*$t*$p2.y;
			return new Point(xP ,yP);
		}
	}
}