package {
	
	
	import com.ytti.mesh.core.BitmapDataMesh;
	
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Sprite;
	import flash.display.StageAlign;
	import flash.display.StageQuality;
	import flash.display.StageScaleMode;
	import flash.events.Event;
	import flash.geom.Point;
	
	[SWF(width = "640", height = "480", frameRate = "30", backgroundColor = "0xFFFFFF")]
	public class TestBoneMesh extends Sprite
	{
		[Embed(source="test.jpg")] private var ImageClass:Class;
		private var _bmd:BitmapData;
		private var _mesh:BitmapDataMesh;
		private var _bone:LineBone;
		private var _segmentW:Number = 1;
		private var _segmentH:Number = 7;
		private var _canvas:Sprite;
		
		public function TestBoneMesh()
		{
			stage.quality = StageQuality.BEST;
			stage.scaleMode = StageScaleMode.NO_SCALE;
			stage.align = StageAlign.TOP_LEFT;
			
			addEventListener(Event.ADDED_TO_STAGE , _init );
		}
		
		private function _init(e:Event):void {
			_canvas = addChild(new Sprite()) as Sprite;
			
			_bmd = Bitmap(new ImageClass()).bitmapData;
			_bone = new LineBone(_bmd.width , _bmd.height , _segmentH , true );
			addChild(_bone);
			var initPoint:Array = _getPoint(_bone.getNode());
			_mesh = new BitmapDataMesh( _bmd , initPoint , _segmentW , _segmentH , 0xFF0000 , true );
			
			_resizeHandler();
			stage.addEventListener(Event.RESIZE , _resizeHandler );
			addEventListener(Event.ENTER_FRAME , _loop );
		}
		
		private function _loop(e:Event):void {
			var editPoint:Array = _getPoint(_bone.getNode());
			_mesh.render(_canvas , editPoint );
		}
		
		private function _resizeHandler(e:Event = null):void {
			_canvas.x = (stage.stageWidth - _bmd.width)/2;
			_canvas.y = (stage.stageHeight - _bmd.height)/2;
			_bone.x =_canvas.x;
			_bone.y =_canvas.y;
		}
		
		private function _getPoint($bonenodes:Array):Array {
			var divW:Number = _bmd.width / _segmentW;
			var divH:Number = _bmd.height / _segmentH;
			var cW:Number = _bmd.width/2;
			
			var points:Array = [];
			for(var iy:Number = 0;iy <= _segmentH ;iy++ ){
				for(var ix:Number = 0;ix <= _segmentW;ix++ ){
					var bonenode:Point = $bonenodes[iy] as Point;
					var px:Number = ix * divW + (bonenode.x - cW);
					//var py:Number = iy * divH;
					var py:Number = bonenode.y;
					var pt:Point = new Point(px , py);
					//trace(pt + "__" + bonenode);
					points.push(pt);
				}
			}
			
			return points;
		}
	}
}
import flash.display.Sprite;
import flash.events.MouseEvent;
import flash.events.Event;
import flash.geom.Point;

class LineBone extends Sprite {
	private var _bmdWidth:Number;
	private var _bmdHeight:Number;
	private var _divYNum:Number;
	private var _line:Sprite;
	private var _nodes:Array;
	private var _nodeVisible:Boolean;
	
	public function LineBone($bmdWidth:Number , $bmdHeight:Number , $divYNum:Number , $nodeVisible:Boolean = false)
	{
		_bmdWidth = $bmdWidth;
		_bmdHeight = $bmdHeight;
		_divYNum = $divYNum;
		_nodeVisible = $nodeVisible;
		
		_line = new Sprite();
		addChild(_line);
		
		_nodes = [];
		var intervalY:Number = _bmdHeight / _divYNum;
		var cX:Number = _bmdWidth / 2;
		for(var i:Number = 0;i <= _divYNum;i++ ){
			var node:LineBoneNode = new LineBoneNode( cX , intervalY * i ,_nodeVisible);
			_nodes.push(node);
			addChild(node)
		}
		
		addEventListener(Event.ENTER_FRAME , _update );
	}
	private function _update(e:Event):void {
		_render();
	}
	private function _render():void {
		if(!_nodeVisible) return;
		_line.graphics.clear();
		_line.graphics.lineStyle(2 , 0x00FF00);
		for(var i:Number = 0;i < _nodes.length;i++ ){
			var node:LineBoneNode = _nodes[i] as LineBoneNode;
			if(i==0) {
				_line.graphics.moveTo( node.x , node.y );
			} else {
				_line.graphics.lineTo( node.x , node.y );
			}
		}
	}
	public function getNode():Array {
		var nodes:Array = [];
		for(var i:Number = 0;i < _nodes.length;i++ ){
			var node:LineBoneNode = _nodes[i] as LineBoneNode;
			nodes.push(new Point( node.x , node.y ));
		}
		return nodes;
	}
}	

class LineBoneNode extends Sprite {
	private var _nodeVisible:Boolean;
	public function LineBoneNode($x:Number , $y:Number , $nodeVisible:Boolean = false):void
	{
		this.x = $x;
		this.y = $y;
		_nodeVisible = $nodeVisible;
		
		if(_nodeVisible) {
			this.graphics.beginFill(0x00FF00 , 1 );
			this.graphics.drawCircle(0,0,5 );
			this.graphics.endFill();
		}
		
		this.addEventListener(MouseEvent.MOUSE_DOWN , _mouseDown );
	}
	
	private function _mouseDown(e:MouseEvent):void {
		this.startDrag();
		stage.addEventListener(MouseEvent.MOUSE_UP , _mouseUp );
	}
	
	private function _mouseUp(e:MouseEvent):void {
		stage.removeEventListener(MouseEvent.MOUSE_UP , _mouseUp );
		this.stopDrag();
	}
}
